#include <htc.h>
#include "../hardware/display.h"
#include "../hardware/buttons.h"
#include "../utility/delay.h"

void voltmeter(void) {

	// Set ADC clock to FOSC/32.
	ADCS1 = 1;
	// Right-align results.
	ADFM = 1;

	// Switch on the ADC.
	ADON = 1;

	// Run the voltmeter until both buttons are pressed.
	while (BUTTON_1 || BUTTON_2) {
		
		display_off();
		delay_ms(2);
	
		// Take a reading.
		GODONE = 1;
		while (GODONE);
		
		display_on();

		display_print_decimal(0x8000 | (unsigned int)((ADRESH << 8) | ADRESL) * 5000UL / 1023UL);
		display_data[0] |= 0x80; // Decimal point.

		// Delay between readings.
		delay_ms(200);
	}

	// Switch off the ADC.
	ADON = 0;
	
}